#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define endl "\n"
#define all(x) x.begin(), x.end()
#define f first
#define s second
#define pb push_back
#define pop pop_back

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using lll = __int128_t;
using ld = long double;

template <typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

template <typename T>
using ordered_multiset = tree<T, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>;

constexpr int INF = 1e9;
constexpr ll LINF = 1e18;
constexpr ld EPS = 1e-5;
constexpr int MOD = 1e9 + 7, MOD2 = 998244353;

int add(int a, int b, int mod) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}

int sub(int a, int b, int mod) {
    if (a >= b) return a - b;
    return a - b + mod;
}

int mul(int a, int b, int mod) {
    return 1ll * a * b % mod;
}

int binpow(int a, int b, int mod) {
    if (b == 0) return 1;
    int x = binpow(a, b / 2, mod);
    if (b % 2) return mul(x, mul(x, a, mod), mod);
    return mul(x, x, mod);
}

mt19937 rnd(1337228666);

int lca(int u, int v, vector <int> &p, vector <int> &d) {
    while (d[u] > d[v]) u = p[u];
    while (d[u] < d[v]) v = p[v];
    while (u != v) u = p[u], v = p[v];
    return u;
}

bool func(vector <vector <int>> &groups, vector <int> &a, vector <int> &p, vector <int> &d) {
    assert(groups.size() == a.size());
    // теперь надо просто проверить, что LCA(groups[i]) == a[i]
    // черт это же LCA надо за быстро делать..., с другой стороны, дерево высотой не более чем 10, есть ли смысл это как-то оптимизировать?
    for (int i = 0; i < a.size(); i++) {
        int l = groups[i][0];
        for (int j = 1; j < groups[i].size(); j++) l = lca(l, groups[i][j], p, d);
        if (l != a[i]) return false;
    }
    return true;
}

int ans(vector <int> &lst, int k, vector <vector <int>> &groups, vector <int> &a, vector <int> &p, vector <int> &d) {
    if (lst.size() < k) return 0;
    if (k == 0) {
        return func(groups, a, p, d);
    }
    int sum = 0;
    for (int mask = 1; mask < (1 << lst.size()); mask++) {
        vector <int> nlst, nnlst;
        for (int bit = 0; bit < lst.size(); bit++) {
            if (mask >> bit & 1) {
                nlst.pb(lst[bit]);
            } else {
                nnlst.pb(lst[bit]);
            }
        }
        groups.pb(nlst);
        sum = add(sum, ans(nnlst, k - 1, groups, a, p, d), MOD2);
        groups.pop_back();
    }
    return sum;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector <int> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i];
        a[i]--;
    }

    vector <int> p(n), d(n);
    int x;
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        d[i] = d[p[i]] + 1;
    }
    vector <int> lst(n);
    iota(all(lst), 0);
    vector <vector <int>> groups;
    cout << ans(lst, k, groups, a, p, d) << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}